﻿using System;
using System.ComponentModel;
using System.Windows.Threading;

namespace Silverlight3Clock {
    
    public class Clock : INotifyPropertyChanged {

        private DispatcherTimer _timer;

        private string _time;

        public Clock() {
            // Setup Timer
            _timer_Tick(null, null);
            _timer = new DispatcherTimer();
            _timer.Interval = new TimeSpan(0, 0, 1);
            _timer.Tick += _timer_Tick;
            _timer.Start();
        }

        void _timer_Tick(object sender, EventArgs e) {
            Time = DateTime.Now.ToString("HH:mm:ss");
        }

        public string Time {
            get {
                return _time;
            }
            set {
                _time = value;
                OnPropertyChanged("Time");
            }
        }

        public event PropertyChangedEventHandler PropertyChanged;

        protected virtual void OnPropertyChanged(string propertyName) {
            if (PropertyChanged != null) {
                PropertyChanged(this, new PropertyChangedEventArgs(propertyName));
            }
        }

    }
}
